## mingw-w64-scnlib-4.0.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(
        scn
        VERSION 4.0.1
        DESCRIPTION "scanf for modern C++"
        HOMEPAGE_URL "https://scnlib.dev"
        LANGUAGES CXX
)

option(SCN_DISABLE_TOP_PROJECT OFF)

if (CMAKE_VERSION VERSION_LESS 3.21)
    get_property(not_top DIRECTORY PROPERTY PARENT_DIRECTORY)
    if (NOT not_top)
        set(PROJECT_IS_TOP_LEVEL ON)
    endif ()
endif ()
if (PROJECT_IS_TOP_LEVEL AND NOT SCN_DISABLE_TOP_PROJECT)
    set(SCN_IS_TOP_PROJECT ON)
else ()
    set(SCN_IS_TOP_PROJECT OFF)
endif ()

if (SCN_IS_TOP_PROJECT AND NOT CMAKE_BUILD_TYPE)
    message(WARNING "No CMAKE_BUILD_TYPE set, defaulting to Release")
    set(CMAKE_BUILD_TYPE Release CACHE STRING "")
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)

include(cmake/util.cmake)
include(cmake/options.cmake)
include(cmake/buildflags.cmake)
include(cmake/dependencies.cmake)
include(cmake/sanitizers.cmake)

set(SCN_PUBLIC_HEADERS
        include/scn/fwd.h
        include/scn/scan.h
        include/scn/ranges.h
        include/scn/regex.h
        include/scn/istream.h
        include/scn/xchar.h
)
set(SCN_PRIVATE_HEADERS
        src/scn/impl.h
)
set(SCN_PRIVATE_SOURCES
        src/scn/impl.cpp
)

add_library(scn
        "${SCN_PUBLIC_HEADERS}"
        "${SCN_PRIVATE_HEADERS}"
        "${SCN_PRIVATE_SOURCES}"
)
target_include_directories(scn
        PUBLIC
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        PRIVATE
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)
target_link_libraries(scn PRIVATE
        ${SCN_FAST_FLOAT_TARGET}
        ${SCN_REGEX_BACKEND_TARGET}
)
set_library_flags(scn)

set_property(TARGET scn PROPERTY SOVERSION 4)
add_library(scn::scn ALIAS scn)

add_library(scn_internal INTERFACE)
target_link_libraries(scn_internal INTERFACE
        scn::scn
        ${SCN_FAST_FLOAT_TARGET}
        ${SCN_REGEX_BACKEND_TARGET}
)
target_include_directories(scn_internal
        INTERFACE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)
set_interface_flags(scn_internal)

add_subdirectory(scripts)

add_subdirectory(benchmark)
add_subdirectory(docs)
add_subdirectory(examples)

enable_testing()
add_subdirectory(tests)

include(cmake/install.cmake)

=== benchmark/CMakeLists.txt ===
if (SCN_BENCHMARKS)
    add_subdirectory(runtime)
endif()

if (SCN_BENCHMARKS_BINARYSIZE)
    add_subdirectory(binarysize)
endif()

if (SCN_BENCHMARKS_BUILDTIME)
    add_subdirectory(buildtime)
endif()

=== docs/CMakeLists.txt ===
if (NOT SCN_DOCS)
    return()
endif()

find_package(Doxygen QUIET)
if (NOT DOXYGEN_FOUND)
    message(STATUS "Target 'scn_docs' disabled for scnlib (doxygen required)")
    return()
endif()

find_package(poxy QUIET)
if (NOT POXY_FOUND)
    message(STATUS "Target 'scn_docs' disabled for scnlib (poxy required)")
    return()
endif()

set(SCN_ABSOLUTE_PUBLIC_HEADERS "${SCN_PUBLIC_HEADERS}")
list(TRANSFORM SCN_ABSOLUTE_PUBLIC_HEADERS PREPEND "${CMAKE_CURRENT_LIST_DIR}/../")

add_custom_command(
        COMMAND ${POXY_EXECUTABLE}
        WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}"
        OUTPUT "${CMAKE_CURRENT_LIST_DIR}/html"
        MAIN_DEPENDENCY "${CMAKE_CURRENT_LIST_DIR}/poxy.toml"
        DEPENDS
            "${CMAKE_CURRENT_LIST_DIR}/pages/faq.md"
            "${CMAKE_CURRENT_LIST_DIR}/pages/guide.md"
            "${CMAKE_CURRENT_LIST_DIR}/pages/mainpage.md"
            "${CMAKE_CURRENT_LIST_DIR}/../CHANGELOG.md"
            "${CMAKE_CURRENT_LIST_DIR}/script/monospace-headers.js"
            "${SCN_ABSOLUTE_PUBLIC_HEADERS}"
        COMMENT "Generating docs"
        VERBATIM)
add_custom_target(scn_docs DEPENDS "${CMAKE_CURRENT_LIST_DIR}/html")

=== docs/requirements.txt ===
poxy

=== examples/CMakeLists.txt ===
if (NOT SCN_EXAMPLES)
    return()
endif()

add_library(scn_examples_base INTERFACE)
target_link_libraries(scn_examples_base INTERFACE scn_sanitizers)

add_executable(scn_example_1 example_1.cpp)
target_link_libraries(scn_example_1 scn::scn scn_examples_base)

add_executable(scn_example_2 example_2.cpp)
target_link_libraries(scn_example_2 scn::scn scn_examples_base)

add_executable(scn_example_3 example_3.cpp)
target_link_libraries(scn_example_3 scn::scn scn_examples_base)

add_executable(scn_example_4 example_4.cpp)
target_link_libraries(scn_example_4 scn::scn scn_examples_base)

add_executable(scn_example_5 example_5.cpp)
target_link_libraries(scn_example_5 scn::scn scn_examples_base)

=== scripts/CMakeLists.txt ===
if (SCN_COVERAGE)
    add_custom_target(scn_coverage_script_prepare ALL
            COMMAND ${CMAKE_COMMAND} -E copy
            "${CMAKE_CURRENT_LIST_DIR}/coverage.sh"
            "${CMAKE_BINARY_DIR}"
            COMMENT "Copying coverage script")
endif()

=== tests/CMakeLists.txt ===
add_subdirectory(unittests)
add_subdirectory(fuzz)

=== benchmark/binarysize/CMakeLists.txt ===
function(generate_binarysize_test_files template outdir sources)
    set(binarysize_test_path "${CMAKE_CURRENT_BINARY_DIR}/${outdir}/")
    set(binarysize_test_main "${binarysize_test_path}/binarysize_test_main.cpp")
    set(binarysize_test_header "${binarysize_test_path}/binarysize_test_all.h")

    file(WRITE "${binarysize_test_main}" "#include \"binarysize_test_all.h\"\n")
    file(APPEND "${binarysize_test_main}" "int main() {\n")

    set(source_files_list "${binarysize_test_main}" "${binarysize_test_header}")

    foreach (i RANGE 16)
        set(output_file "${binarysize_test_path}/binarysize_test_tmp_${i}.cpp")

        file(READ "${template}" template_contents)
        string(REPLACE "do_scan" "do_scan_${i}" template_contents "${template_contents}")
        string(REPLACE "42" "${i}" template_contents "${template_contents}")
        file(WRITE "${output_file}" "${template_contents}")

        list(APPEND source_files_list "${output_file}")

        file(APPEND "${binarysize_test_main}" "do_scan_${i}();\n")
        file(APPEND "${binarysize_test_header}" "void do_scan_${i}();\n")
    endforeach()

    file(APPEND "${binarysize_test_main}" "return 0;\n}\n")
    set(${sources} "${source_files_list}" PARENT_SCOPE)
endfunction()

add_library(scn_benchmark_binarysize_base INTERFACE)
target_compile_options(scn_benchmark_binarysize_base INTERFACE
        $<$<CXX_COMPILER_ID:GNU>:
        -Wno-unused
        -Wno-unused-but-set-variable
        -Wno-redundant-decls
        -Wno-missing-declarations>
        $<$<CXX_COMPILER_ID:Clang>:
        -Wno-unused-variable
        -Wno-missing-prototypes>)
disable_msvc_secure_flags(scn_benchmark_binarysize_base INTERFACE)

# control
generate_binarysize_test_files("${CMAKE_CURRENT_LIST_DIR}/template-control.cpp" out/control binarysize_control_sources)
add_executable(scn_benchmark_binarysize_control "${binarysize_control_sources}")
target_link_libraries(scn_benchmark_binarysize_control scn_benchmark_binarysize_base)

# iostream
generate_binarysize_test_files("${CMAKE_CURRENT_LIST_DIR}/template-iostream.cpp" out/iostream binarysize_iostream_sources)
add_executable(scn_benchmark_binarysize_iostream "${binarysize_iostream_sources}")
target_link_libraries(scn_benchmark_binarysize_iostream scn_benchmark_binarysize_base)

# scanf
generate_binarysize_test_files("${CMAKE_CURRENT_LIST_DIR}/template-scanf.cpp" out/scanf binarysize_scanf_sources)
add_executable(scn_benchmark_binarysize_scanf "${binarysize_scanf_sources}")
target_link_libraries(scn_benchmark_binarysize_scanf scn_benchmark_binarysize_base)

# scnlib
generate_binarysize_test_files("${CMAKE_CURRENT_LIST_DIR}/template-scnlib.cpp" out/scnlib binarysize_scnlib_sources)
add_executable(scn_benchmark_binarysize_scnlib "${binarysize_scnlib_sources}")
target_link_libraries(scn_benchmark_binarysize_scnlib scn_internal scn_benchmark_binarysize_base)

add_custom_target(scn_benchmark_binarysize_prepare ALL
        COMMAND ${CMAKE_COMMAND} -E copy
        "${CMAKE_CURRENT_LIST_DIR}/binarysize_bench.py"
        "${CMAKE_CURRENT_LIST_DIR}/run_binarysize_bench.py"
        "${CMAKE_BINARY_DIR}/benchmark/binarysize"
        COMMENT "Copying binary size benchmark scripts")

=== benchmark/buildtime/CMakeLists.txt ===
add_custom_target(scn_benchmark_buildtime_prepare ALL
        COMMAND ${CMAKE_COMMAND} -E copy
        "${CMAKE_CURRENT_LIST_DIR}/empty.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/cstdio.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/iostream.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/scnlib.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/run-buildtime-benchmarks.sh"
        "${CMAKE_BINARY_DIR}/benchmark/buildtime"
        COMMENT "Copying build time benchmark scripts")

=== benchmark/runtime/CMakeLists.txt ===
add_library(scn_benchmark_runtime_common INTERFACE)
target_include_directories(scn_benchmark_runtime_common INTERFACE common)
target_compile_options(scn_benchmark_runtime_common INTERFACE
        $<$<CXX_COMPILER_ID:GNU>:
        -Wno-unused
        -Wno-redundant-decls>
        $<$<CXX_COMPILER_ID:Clang>:
        -Wno-unused-variable
        -Wno-used-but-marked-unused
        -Wno-gnu-zero-variadic-macro-arguments
        -Wno-global-constructors
        -Wno-exit-time-destructors
        -Wno-weak-vtables
        >)
disable_msvc_secure_flags(scn_benchmark_runtime_common INTERFACE)

function(scn_make_runtime_benchmark target)
    add_executable(${target} ${ARGN})
    target_link_libraries(${target} PRIVATE
        scn_internal benchmark::benchmark benchmark::benchmark_main scn_benchmark_runtime_common)
endfunction()

add_subdirectory(basic)
add_subdirectory(integer)
add_subdirectory(float)
add_subdirectory(string)

=== tests/consumer-test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(scn-consumer CXX)

find_package(scn CONFIG REQUIRED)

add_executable(scn-consumer main.cpp)
target_link_libraries(scn-consumer PRIVATE scn::scn)

=== tests/fuzz/CMakeLists.txt ===
if (NOT SCN_FUZZING)
    return()
endif ()

add_library(scn_fuzz_base INTERFACE)
target_link_libraries(scn_fuzz_base INTERFACE scn scn_fuzzer scn_internal)

function(add_fuzzer name)
    add_executable(scn_fuzz_${name}
            fuzz.h
            ${name}_fuzz.cpp)
    target_link_libraries(scn_fuzz_${name} PRIVATE scn scn_internal)
    if (SCN_FUZZING_LDFLAGS)
        target_link_options(scn_fuzz_${name} PRIVATE ${SCN_FUZZING_LDFLAGS})
    else ()
        target_link_libraries(scn_fuzz_${name} PRIVATE scn_fuzzer)
    endif ()
endfunction()

add_fuzzer(int)
add_fuzzer(float)
add_fuzzer(string)
add_fuzzer(format)
add_fuzzer(chrono)
add_fuzzer(string_impl)

add_custom_target(scn_fuzz_prepare ALL
        COMMAND ${CMAKE_COMMAND} -E copy
        "${CMAKE_CURRENT_LIST_DIR}/run-fuzz.sh"
        "${CMAKE_BINARY_DIR}/tests/fuzz"
        COMMENT "Copying fuzzer scripts")

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=scnlib
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=4.0.1
pkgrel=1
pkgdesc="scanf for modern C++. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://www.scnlib.dev'
msys2_repository_url="https://github.com/eliaskosunen/scnlib"
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-fast_float")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
checkdepends=("${MINGW_PACKAGE_PREFIX}-gtest")
source=("https://github.com/eliaskosunen/scnlib/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-Fix-incompatibility-with-newer-fast_float.patch::https://github.com/eliaskosunen/scnlib/commit/144a590f.patch")
sha256sums=('ece17b26840894cc57a7127138fe4540929adcb297524dec02c490c233ff46a7'
            '55a3d94e2241c5268679ae2fe7fe10ee4a00754143d80d72da9d1286dcab5392')

prepare() {
  cd "${_realname}-${pkgver}"
  patch -p1 -i "${srcdir}"/001-Fix-incompatibility-with-newer-fast_float.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DSCN_USE_EXTERNAL_FAST_FLOAT=ON \
      -DSCN_REGEX_BACKEND="std" \
      -DSCN_INSTALL=ON \
      -DSCN_PEDANTIC=OFF \
      -DSCN_WERROR=OFF \
      -DSCN_BENCHMARKS=OFF \
      -DSCN_BENCHMARKS_BUILDTIME=OFF \
      -DSCN_BENCHMARKS_BINARYSIZE=OFF \
      -DSCN_DOCS=OFF \
      -DSCN_EXAMPLES=OFF \
      -DSCN_TESTS=OFF \
      -DBUILD_TESTING=OFF \
      -DSCN_FUZZING=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cmake \
    -DBUILD_TESTING=ON \
    -DSCN_TESTS=ON \
    -DSCN_USE_EXTERNAL_GTEST=ON \
    -S "${_realname}-${pkgver}" \
    -B "build-${MSYSTEM}"
  cmake --build "build-${MSYSTEM}"

  PATH="${srcdir}"/build-${MSYSTEM}:$PATH \
  ctest --output-on-failure --test-dir "build-${MSYSTEM}" || true
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
